<template>
  <div class="app">
    <Header />
    <div class="home-hero">
      <div class="hero-content">
        <span
          class="hero-heading heading1"
          data-editor="Cici Frasier"
          :class="{ changeColor: flag, changeOpacity: scrolling }"
        >
          Stunning presentations.
        </span>
        <span
          class="hero-heading heading2"
          :class="{ changeColor: checkHeight, changeOpacity: scrolling }"
          data-editor="Larry Weber"
          >Made together.</span
        >
      </div>
      <p class="hero-subtitle">
        Pitch combines the best parts of productivity, design and presentations
        software to help fast-moving teams create beautifully designed decks in
        minutes
      </p>
    </div>
    <div class="homepage-image">
      <img src="../assets/home-hero-ui.webp" alt="" />
    </div>
    <div class="content">
      <span class="heading">One workspace.</span>
      <br />
      <span class="heading">Boundless possibilities.</span>

      <p class="subtitle">
        From pitch decks to project plans, conference keynotes to all-hands
        meetings, our presentation software gives teams space to share all the
        work that matters.
      </p>
    </div>
    <div class="content">
      <span class="heading">One workspace.</span>
      <br />
      <span class="heading">Boundless possibilities.</span>

      <p class="subtitle">
        From pitch decks to project plans, conference keynotes to all-hands
        meetings, our presentation software gives teams space to share all the
        work that matters.
      </p>
    </div>
    <div class="content">
      <span class="heading">One workspace.</span>
      <br />
      <span class="heading">Boundless possibilities.</span>

      <p class="subtitle">
        From pitch decks to project plans, conference keynotes to all-hands
        meetings, our presentation software gives teams space to share all the
        work that matters.
      </p>
    </div>
    <div class="content">
      <span class="heading">One workspace.</span>
      <br />
      <span class="heading">Boundless possibilities.</span>

      <p class="subtitle">
        From pitch decks to project plans, conference keynotes to all-hands
        meetings, our presentation software gives teams space to share all the
        work that matters.
      </p>
    </div>
  </div>
</template>
<script>
import Header from "./HeaderComponent.vue";
const heroSubtitle = document.getElementsByClassName("hero-subtitle");
const heroContent = document.getElementsByClassName("hero-content");
const heroImage = document.getElementsByTagName("img");

export default {
  data() {
    return {
      scrolling: false,
      checkHeight: false,
      flag: false,
    };
  },
  components: {
    Header,
  },
  methods: {
    fadeSubtitle() {
      //Change Opacity of before and After
      if (window.scrollY >= 2) {
        this.scrolling = true;
      } else {
        this.scrolling = false;
      }
      //Fade Subtitle Text
      let opacity = (heroSubtitle[0].offsetHeight - scrollY) / 10;
      heroSubtitle[0].style.opacity = opacity;

      //Scale and Translate Headings
      let y = window.pageYOffset / 10;
      let scale =
        1.0 -
        (document.documentElement.scrollTop * window.devicePixelRatio) /
          document.documentElement.offsetHeight;

      heroContent[0].style.transform = `translateY(${
        y < 36 ? y : 36
      }em) scale(${scale > 0.87 ? scale : 0.87})`;

      //Scale and Transform Image
      let imageY = 1 - window.pageYOffset / 10;
      let imageScale =
        1.0 +
        document.documentElement.scrollTop /
          document.documentElement.offsetHeight;
      heroImage[0].style.transform = `translateY(${
        imageY >= -8 ? imageY : -8
      }em) scale(${imageScale < 1.1 ? imageScale : 1.1})`;

      console.log(document.documentElement.scrollTop - window.devicePixelRatio);
      //Change Text Color
      if (y >= 12.5) {
        this.checkHeight = true;
      } else {
        this.checkHeight = false;
      }

      if (y >= 15) {
        this.flag = true;
      } else {
        this.flag = false;
      }
    },
  },
  mounted() {
    window.onscroll = this.fadeSubtitle;
  },
};
</script>

<style scoped>
/* Hero Content Styling */
.home-hero {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  margin-top: 21vh;
}

.hero-content {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  z-index: 90;
  will-change: all;
}

.changeColor {
  color: white !important;
  transition-duration: 0.3s;
}

.hero-subtitle {
  font-size: calc(0.5em + 1vw);
  font-weight: 300;
  width: 46ch;
  animation: fade-up 1s ease;
  will-change: opacity;
  margin-top: 5%;
  /* animation-delay: 0.8s; */
}

@keyframes fade-up {
  from {
    transform: translateY(50%);
    opacity: 0;
  }
  to {
    transform: translateY(0%);
    opacity: 1;
  }
}

.hero-content .hero-heading {
  font-size: calc(4vw + 1em);
  font-weight: 900;
  color: black;
  z-index: 100;
}

.heading1 {
  position: relative;
  animation: fade-up 0.3s ease;
}

.heading1::before {
  position: absolute;
  bottom: 100%;
  left: -1px;
  display: block;
  padding: 0.1em 0.4em;
  content: attr(data-editor);
  transition: opacity 0.1s 0.25s;
  opacity: 0;
  color: #000;
  border-radius: 0.3rem 0.3rem 0 0;
  background: #aab6fe;
  font: calc(0.4rem + 0.5vh) "Eina01", -apple-system, blinkmacsystemfont,
    "Segoe UI", roboto, helvetica, arial, sans-serif, "Apple  Color Emoji",
    "Segoe UI Emoji", "Segoe  UI Symbol";
  line-height: 1.6;
}

.heading1::after {
  position: absolute;
  top: -1px;
  right: -1px;
  bottom: -1px;
  left: -1px;
  display: block;
  content: "";
  transition: opacity 0.1s 0.25s;
  opacity: 0;
  border: 1px dashed #aab6fe;
}

.heading2::before {
  position: absolute;
  bottom: 100%;
  left: -1px;
  display: block;
  padding: 0.1em 0.4em;
  content: attr(data-editor);
  transition: opacity 0.1s 0.25s;
  opacity: 0;
  color: #000;
  border-radius: 0.3rem 0.3rem 0 0;
  background: #fdd60d;
  font: calc(0.4rem + 0.5vw) "Eina01", -apple-system, blinkmacsystemfont,
    "Segoe UI", roboto, helvetica, arial, sans-serif, "Apple  Color Emoji",
    "Segoe UI Emoji", "Segoe  UI Symbol";
  line-height: 1.6;
}

.heading2::after {
  position: absolute;
  top: -1px;
  right: -1px;
  bottom: -1px;
  left: -1px;
  display: block;
  content: "";
  transition: opacity 0.1s 0.25s;
  opacity: 0;
  border: 1px dashed #fdd60d;
}

.changeOpacity::before {
  opacity: 1;
}

.changeOpacity::after {
  opacity: 1;
}

.heading2 {
  margin-top: 1%;
  position: relative;
  animation: fade-up 1s ease;
}

/* HomePage-Image */
.homepage-image {
  margin-top: 6%;
  /* margin-bottom: -15%; */
}

.homepage-image img {
  width: 80%;
  box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px;
  border-radius: 10px;
  z-index: -1;
  position: relative;
  will-change: all;
}

@keyframes translate-up {
  from {
    transform: translateY(0px);
  }
  to {
    transform: translateY(-400px);
  }
}

.content {
  margin-top: 100px;
  display: flex;
  flex-direction: column;
  align-items: center;
}

.content .heading {
  font-size: calc(1.5rem + 2vw);
  font-weight: 900;
}

.content .subtitle {
  font-size: calc(0.5em + 1vw);
  font-weight: 200;
  width: 48ch;
}
</style>
